var schedule = IR.GetScheduler("Schedule 1");
// creating a string with schedule data
var EventChanger = function() {
  var EventBuff = [];
  var Event = function(in_Name, in_Start, in_Finish) {
    this.Name = in_Name;     // event name
    this.Start = in_Start;   // event start date-time
    this.Finish = in_Finish  // event finish date-time
  }  
// writing schedule data in virtual tag
  this.Write = function(in_events) {
    EventBuff = [];
    for(i in in_events) {  
      var NEvent = new Event(in_events[i].Name, in_events[i].Start, in_events[i].End);
      NEvent.Enabled = in_events[i].Enabled;
      EventBuff.push(NEvent);
    }
    var string = JSON.Stringify(EventBuff);                     
    IR.SetVariable("Server.Tags.EventData_from_server", string);   
  }   
// reading schedule data in virtual tag 
  this.Read = function(in_schedule, in_NewData) { 
    EventEdit = in_schedule.GetEvent(in_NewData[1]);
    EventEdit.Start = Math.floor(new Date(in_NewData[0]) / 1000);
    EventEdit.End = Math.floor(new Date(in_NewData[2]) / 1000);
    EventEdit.Enabled = (in_NewData[3] == 1);
    EventEdit.Done();  // event update
  }  
}

var EventsObj = new EventChanger();
// getting schedule data at server start
IR.AddListener(IR.EVENT_START,0,function() {
  schedule = IR.GetScheduler("Schedule 1");
  events = schedule.GetEvents();
  EventsObj.Write(events);        
});

// getting new data from panel
IR.SetGlobalListener(IR.EVENT_GLOBAL_TAG_CHANGE, function(in_sName, in_sValue) {
  var newData = in_sValue.split(',');
  EventsObj.Read(schedule, newData);
  events = schedule.GetEvents();
  EventsObj.Write(events); 
});
 
// subscribing for tag changes
IR.SubscribeTagChange("Server.Channels.EventData_to_server");

